package com.FranckBarbier.New_York_City_Penitentiary.services;

@org.springframework.web.bind.annotation.RestController
public class Criminal_caseCRUD implements JSON_service {

    @org.springframework.beans.factory.annotation.Autowired
    private com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_caseDAO _criminal_caseDAO;

    @Override
    public String to_JSON(QUERY type) {
        java.util.List<com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case> criminal_cases
                = type == QUERY.ALL_CRIMINAL_CASES ? _criminal_caseDAO.findAll() : new java.util.LinkedList<>();
        javax.json.JsonArrayBuilder _criminal_cases = javax.json.Json.createArrayBuilder();
        for (com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case criminal_case : criminal_cases) {
            javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
            builder.add("CRIMINAL_CASE_NUMBER", criminal_case.get_criminal_case_number());
            builder.add("JURISDICTION_NAME", criminal_case.get_jurisdiction_name());
            _criminal_cases.add(builder.build());
        }
        return _criminal_cases.build().toString();
    }

    // http://localhost:8080/NYCP/API/criminal_cases
    @org.springframework.web.bind.annotation.GetMapping(value = "/criminal_cases")
    public String all() {
        return to_JSON(QUERY.ALL_CRIMINAL_CASES);
    }

    // https://www.baeldung.com/spring-requestparam-vs-pathvariable
    // http://localhost:8080/NYCP/API/criminal_cases/get?criminal_case_number=M13000&jurisdiction_name=Marseille
    @org.springframework.web.bind.annotation.GetMapping(value = "/criminal_cases/get")
    public String get(@org.springframework.web.bind.annotation.RequestParam String criminal_case_number,
            @org.springframework.web.bind.annotation.RequestParam String jurisdiction_name) {
        java.util.Optional<com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case> criminal_case
                = _criminal_caseDAO.findById(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_casePK(criminal_case_number, jurisdiction_name));
        javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
        if (criminal_case.isPresent()) {
            builder.add("CRIMINAL_CASE_NUMBER", criminal_case.get().get_criminal_case_number());
            builder.add("JURISDICTION_NAME", criminal_case.get().get_jurisdiction_name());
        }
        return builder.build().toString();
    }

    // curl -X POST -d 'criminal_case_number=P64000&jurisdiction_name=Pau' http://localhost:8080/NYCP/API/criminal_cases
    @org.springframework.web.bind.annotation.PostMapping(value = "/criminal_cases")
    public void post(@org.springframework.web.bind.annotation.RequestParam String criminal_case_number,
            @org.springframework.web.bind.annotation.RequestParam String jurisdiction_name) {
        _criminal_caseDAO.save(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case(criminal_case_number, jurisdiction_name));
    }

    @org.springframework.web.bind.annotation.PutMapping(value = "/criminal_cases")
    public void put(@org.springframework.web.bind.annotation.RequestBody com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case criminal_case) {
        _criminal_caseDAO.save(criminal_case);
    }

    // https://www.baeldung.com/spring-vs-jta-transactional
    // curl -X DELETE http://localhost:8080/NYCP/API/criminal_cases/delete/P64000/Pau
    @org.springframework.transaction.annotation.Transactional(rollbackFor = RuntimeException.class, noRollbackFor = RuntimeException.class)
    @org.springframework.web.bind.annotation.DeleteMapping(value = "/criminal_cases/delete/{criminal_case_number}/{jurisdiction_name}")
    public void delete(@org.springframework.web.bind.annotation.PathVariable String criminal_case_number,
            @org.springframework.web.bind.annotation.PathVariable String jurisdiction_name) {
        try {
            _criminal_caseDAO.deleteById(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_casePK(criminal_case_number, jurisdiction_name));
        } catch (RuntimeException re) {
            System.err.println(re.getMessage());
        }
    }
}
