package com.FranckBarbier.New_York_City_Penitentiary.services;

@org.springframework.web.bind.annotation.RestController
public class Judicial_decisionCRUD implements JSON_service {

    @org.springframework.beans.factory.annotation.Autowired
    private com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decisionDAO _judicial_decisionDAO;

    @Override
    public String to_JSON(QUERY type) {
        java.util.List<com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decision> judicial_decisions
                = type == QUERY.ALL_JUDICIAL_DECISIONS ? _judicial_decisionDAO.findAll() : new java.util.LinkedList<>();
        javax.json.JsonArrayBuilder _judicial_decisions = javax.json.Json.createArrayBuilder();
        for (com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decision judicial_decision : judicial_decisions) {
            javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
            builder.add("DECISION_TYPE_NUMBER", judicial_decision.get_decision_type_number());
            builder.add("PRISON_FILE_NUMBER", judicial_decision.get_prison_file_number());
            builder.add("DATE_OF_DECISION", judicial_decision.get_date_of_decision().toString());
            _judicial_decisions.add(builder.build());
        }
        return _judicial_decisions.build().toString();
    }

    @org.springframework.web.bind.annotation.GetMapping(value = "/judicial_decisions")
    public String all() {
        return to_JSON(QUERY.ALL_JUDICIAL_DECISIONS);
    }

    @org.springframework.web.bind.annotation.GetMapping(value = "/judicial_decisions/get")
    public String get(@org.springframework.web.bind.annotation.RequestParam String decision_type_number,
            @org.springframework.web.bind.annotation.RequestParam String prison_file_number,
            @org.springframework.web.bind.annotation.RequestParam java.util.Date date_of_decision) {
        java.util.Optional<com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decision> judicial_decision
                = _judicial_decisionDAO.findById(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decisionPK(decision_type_number, prison_file_number, date_of_decision));
        javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
        if (judicial_decision.isPresent()) {
            builder.add("DECISION_TYPE_NUMBER", judicial_decision.get().get_decision_type_number());
            builder.add("PRISON_FILE_NUMBER", judicial_decision.get().get_prison_file_number());
            builder.add("DATE_OF_DECISION", judicial_decision.get().get_date_of_decision().toString());
        }
        return builder.build().toString();
    }

    @org.springframework.web.bind.annotation.PostMapping(value = "/judicial_decisions", // <=> '@RequestMapping(method = RequestMethod.POST)'
            consumes = org.springframework.http.MediaType.APPLICATION_JSON_VALUE)
    public void post(@org.springframework.web.bind.annotation.RequestBody com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decision decision) {
        _judicial_decisionDAO.save(decision);
    }

    @org.springframework.web.bind.annotation.PutMapping(value = "/judicial_decisions")
    public void put(@org.springframework.web.bind.annotation.RequestBody com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decision decision) {
        _judicial_decisionDAO.save(decision);
    }

    @org.springframework.web.bind.annotation.DeleteMapping(value = "/judicial_decisions/delete/{decision_type_number}/{prison_file_number}/{date_of_decision}")
    public void delete(@org.springframework.web.bind.annotation.PathVariable String decision_type_number,
            @org.springframework.web.bind.annotation.PathVariable String prison_file_number,
            @org.springframework.web.bind.annotation.PathVariable java.util.Date date_of_decision) {
        _judicial_decisionDAO.deleteById(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Judicial_decisionPK(decision_type_number, prison_file_number, date_of_decision));
    }
}
