package com.FranckBarbier.New_York_City_Penitentiary.services;

@org.springframework.web.bind.annotation.RestController
public class OffenseCRUD implements JSON_service {

    @org.springframework.beans.factory.annotation.Autowired
    private com.FranckBarbier.New_York_City_Penitentiary.persistence.PrisonerDao _prisonerDao;

    java.util.Optional<com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner> _prisoner = java.util.Optional.empty();

    @Override
    public String to_JSON(QUERY type) {
        java.util.Set<com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case> offenses
                = type == QUERY.ALL_OFFENSES && _prisoner.isPresent() ? _prisoner.get().get_offense() : new java.util.HashSet<>();
        javax.json.JsonArrayBuilder _offenses = javax.json.Json.createArrayBuilder();
        for (com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case criminal_case : offenses) {
            javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
            builder.add("CRIMINAL_CASE_NUMBER", criminal_case.get_criminal_case_number());
            builder.add("JURISDICTION_NAME", criminal_case.get_jurisdiction_name());
            _offenses.add(builder.build());
        }
        return _offenses.build().toString();
    }

    // http://localhost:8080/NYCP/API/offenses/get/2007
    @org.springframework.web.bind.annotation.GetMapping(value = "/offenses/get/{prison_file_number}")
    public String get(@org.springframework.web.bind.annotation.PathVariable String prison_file_number) {
        _prisoner = _prisonerDao.findById(prison_file_number);
        return to_JSON(QUERY.ALL_OFFENSES);
    }

    // curl -X POST -d 'prison_file_number=2007&criminal_case_number=P64000&jurisdiction_name=Pau' http://localhost:8080/NYCP/API/offenses
    @org.springframework.web.bind.annotation.PostMapping(value = "/offenses")
    public void post(@org.springframework.web.bind.annotation.RequestParam String prison_file_number,
            @org.springframework.web.bind.annotation.RequestParam String criminal_case_number,
            @org.springframework.web.bind.annotation.RequestParam String jurisdiction_name) {
        _prisoner = _prisonerDao.findById(prison_file_number);
        if (_prisoner.isPresent()) {
            java.util.Set<com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case> offenses = _prisoner.get().get_offense();
            offenses.add(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case(criminal_case_number, jurisdiction_name));
            _prisoner.get().set_offense(offenses);
            _prisonerDao.save(_prisoner.get());
        }
    }

    // curl -X DELETE -d 'prison_file_number=2007&criminal_case_number=P64000&jurisdiction_name=Pau' http://localhost:8080/NYCP/API/offenses
    @org.springframework.web.bind.annotation.DeleteMapping(value = "/offenses")
    public void delete(@org.springframework.web.bind.annotation.RequestParam String prison_file_number,
            @org.springframework.web.bind.annotation.RequestParam String criminal_case_number,
            @org.springframework.web.bind.annotation.RequestParam String jurisdiction_name) {
        _prisoner = _prisonerDao.findById(prison_file_number);
        if (_prisoner.isPresent()) {
            java.util.Set<com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case> offenses = _prisoner.get().get_offense();
            offenses.remove(new com.FranckBarbier.New_York_City_Penitentiary.persistence.Criminal_case(criminal_case_number, jurisdiction_name));
            _prisoner.get().set_offense(offenses);
            _prisonerDao.save(_prisoner.get());
        }
    }
}
