package com.FranckBarbier.New_York_City_Penitentiary.services;

@org.springframework.web.bind.annotation.RestController
public class PrisonerCRUD implements JSON_service {

    @org.springframework.beans.factory.annotation.Autowired
    private com.FranckBarbier.New_York_City_Penitentiary.persistence.PrisonerDao _prisonerDao;

    @Override
    public String to_JSON(QUERY type) {
        java.util.List<com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner> prisoners
                = type == QUERY.ALL_PRISONERS ? _prisonerDao.findAll()
                        : type == QUERY.UNDER_REMAND_PRISONERS ? _prisonerDao.under_remand() : new java.util.LinkedList<>();
        javax.json.JsonArrayBuilder _prisoners = javax.json.Json.createArrayBuilder();
        for (com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner prisoner : prisoners) {
            javax.json.JsonObjectBuilder builder = javax.json.Json.createObjectBuilder();
            builder.add("GIVEN_NAME", prisoner.get_given_name());
            builder.add("SURNAME", prisoner.get_surname());
            _prisoners.add(builder.build());
        }
        return _prisoners.build().toString();
    }

    // http://localhost:8080/NYCP/API/prisoners
    @org.springframework.web.bind.annotation.GetMapping(value = "/prisoners")
    public String all() {
        return to_JSON(QUERY.ALL_PRISONERS);
    }

    // http://localhost:8080/NYCP/API/prisoners/2007
    @org.springframework.web.bind.annotation.GetMapping(value = "/prisoners/{prison_file_number}")
    public org.springframework.http.ResponseEntity<com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner> get(@org.springframework.web.bind.annotation.PathVariable String prison_file_number) {
        java.util.Optional<com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner> prisoner = _prisonerDao.findById(prison_file_number);
        if (prisoner.isPresent()) {
            return org.springframework.http.ResponseEntity.ok().body(prisoner.get());
        } else {
            return org.springframework.http.ResponseEntity.notFound().build();
        }
    }

    // https://www.baeldung.com/spring-request-response-body
    // curl -X POST  \
    // -H "Accept: application/json" \
    // -H "Content-Type: application/json" \
    // --data '{"_prison_file_number": "2022", "_given_name": "Franck", <etc.>}' http://localhost:8080/NYCP/API/prisoners
    @org.springframework.web.bind.annotation.PostMapping(value = "/prisoners", // <=> '@RequestMapping(method = RequestMethod.POST)'
            consumes = org.springframework.http.MediaType.APPLICATION_JSON_VALUE)
    public void post(@org.springframework.web.bind.annotation.RequestBody com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner prisoner) {
        _prisonerDao.save(prisoner);
    }

    @org.springframework.web.bind.annotation.PutMapping(value = "/prisoners")
    public void put(@org.springframework.web.bind.annotation.RequestBody com.FranckBarbier.New_York_City_Penitentiary.persistence.Prisoner prisoner) {
        _prisonerDao.save(prisoner);
    }

    // curl -X DELETE http://localhost:8080/NYCP/API/prisoners/delete/2007
    @org.springframework.web.bind.annotation.DeleteMapping(value = "/prisoners/delete/{prison_file_number}")
    public void delete(@org.springframework.web.bind.annotation.PathVariable String prison_file_number) {
        _prisonerDao.deleteById(prison_file_number);
    }

    /**
     * Use case:
     */
    @org.springframework.web.bind.annotation.GetMapping(value = "/under_remand")
    public String under_remand() {
        return to_JSON(QUERY.UNDER_REMAND_PRISONERS);
    }
}
